Program Boundbank
! Finds aa%mis for multiple scales of data, saves as a file
! mask - mask of missing data
! a - size of PEF
! center - position of leading 1 in PEF
! gap - size of zeroes after 1
! sc - scales to use, based on first dimension.  Must include original scale

use sep
use bbank
!use coarsen
!use dottest

implicit none

! declarations
  integer                                  :: nsc, tt(1000), i, nb
  integer, external                        :: getch
  integer, dimension (:),   allocatable    :: nn, center, gap, a, sc, nk
  real,    dimension (:),   allocatable    :: oo, dd, co, cd, obank
  logical, dimension (:),   allocatable    :: lbank
  integer, dimension (:,:), allocatable    :: nbank
  real,    dimension (:),   allocatable    :: mask
  real,    dimension (2)                   :: dot1, dot2

! read from history, param
 !                                                                          write(0,*)"BoundB 1"
  call sep_init(SOURCE)
  dim = sep_dimension()

 !                                                                          write(0,*)"BoundB 2"
  allocate (nn (dim), oo (dim), dd (dim), center (dim), a (dim), gap (dim), nk (dim))
  allocate (co(dim), cd(dim))
!                                                                           write(0,*)"BoundB 3"

  call from_history ("n",nn)
  call from_history ("o",oo)
  call from_history ("d",dd)

 !                                                                          write(0,*)"BoundB 4"
  call from_param ("a",a)

  center = 1
  where (a (2:) > 1) center (:dim-1) = a(:dim-1)/2 + 1
  call from_param ("center",center,center)

  gap = 0
  call from_param ("gap",gap,gap)

!                                                                           write(0,*)"BoundB 5"
  nsc = getch("sc","d",tt)
  allocate( sc (nsc), nbank (nsc,dim) )
  sc(1:nsc)=tt(1:nsc)
  call from_param ("sc", sc)
!
!                                                                           write(0,*)"BoundB 6",product(nn)
! allocations
  allocate (mask (product(nn)))
!                                                                           write(0,*)"BoundB 6.1",sc
! read in mask
  call sep_read( mask )

 !                                                                          write(0,*)"BoundB 7",size(mask)
! find size of misbank
  nbank(1,:)=nn
 !                                                                          write(0,*)"BoundB 7.1"
  nb = product(nn)
        
  if (size(nbank,1)>1) then
     do i=2,nsc
        nbank(i,:) = nn*sc(i)/nn(1)
        nb = nb + product(nbank(i,:))
     end do
  end if
!                                                                                              write(0,*)"BoundB 8"
allocate(lbank(nb),obank(nb))
 !                                                                                             write(0,*)"BoundB 9"
write(0,*)"nb",nb
! put below in subprogram

 call boundbank_find(mask,nn,oo,dd,nbank,a,center,gap,lbank)
!
!call coarsen_init(oo,dd,nn,co,cd,nbank(2,:))
 !                                                                          write(0,*)"BoundB 10"
!call dot_test(coarsen_lop,product(nbank(2,:)),product(nn),dot1,dot2)
!                                                                           write(0,*)"BoundB 11"
write(0,*)"count lbank",nb-count(lbank)
write(0,*)"size lbank",size(lbank)
 obank = 0.
 where (lbank) obank = 1.
 nk=1
 nk(1)=nb
write(0,*)"size obank",size(obank)
! write out boundbak
  call to_history ("n1",nb )
  call to_history ("n2",1 )
  call sep_write (obank)
  call sep_close ()
  call exit (0)
! deallocate stuff
  deallocate(nn,oo,dd,center,a,gap,sc,nbank,mask,lbank,obank)
end Program
