Program Fill

  use sep
  use nhelix
  use io_nfilt
  use fill_ns
  use read_hist_param
  use error_check
  use nbound_bob_mod
  implicit none

  integer                           :: nm,ndat,fiter,fprec,stat
  real                              :: feps,fsig
  integer, dimension(:),allocatable :: nn,fn
  real,    dimension(:),pointer :: oo,dd,fo,fd,data,mask,points,model
  real,    dimension(:,:),pointer   :: coord
  logical, dimension(:),pointer :: maskl
  type(nfilter)                     :: pef
  logical                           :: prec,grid
  character(len=1024)               :: fname

write(0,*)"Fill start"

  call sep_init(SOURCE)
  dim = sep_dimension()

write(0,*)"Fill start2"
  allocate(nn(dim),oo(dim),dd(dim),fn(dim),fo(dim),fd(dim))
  
  call history_read(nn,oo,dd)
  call fillpar_read(fname,feps,fsig,fiter,fprec)
  call fillgpar_read(fn,fo,fd)
  call from_param("grid",grid,.true.)


write(0,*)"Fill par read",nn,oo,dd

!fn=nn;fo=oo;fd=dd
  ndat=product(nn); nm=product(fn)
  allocate(data(ndat),mask(ndat),points(ndat),coord(ndat,dim),model(nm),maskl(ndat))

  call sep_read(data)
  call sep_read(mask,"mask")
  stat=read_nfilt(fname,pef)
  call nbound_bob(nn,pef)
write(0,*)"Fill data, mask and pef read"
call pefcheck(pef)
  prec=.false.
  if (fprec==1) prec=.true.
  maskl=.false.
  where (mask>0) maskl=.true.
  deallocate(mask)

write(0,*)"Fill change mask"

  if (grid==0) then
     call bin2points(data,nn,oo,dd,maskl,points,coord)
     write(0,*)"Fill after bin2points"
     call lmms(maskl,"maskl")
     call rmms(data,"data ")
     call rmms(points,"point")
     call rmms2(coord,"coord")
     call pefcheck(pef)
     call fill(pef,points,coord,model,fn,fo,fd,prec,fsig,feps,fiter)
  else
write(0,*)"before fill_grid"
     call fill_grid(pef,data,maskl,model,prec,fsig,feps,fiter)
  end if

     write(0,*)"Fill after main call"
     call rmms(model,"model")
     call sep_write(model)
     call sep_close()
     deallocate(data,points,coord,model,maskl,nn,oo,dd,fn,fo,fd)
     call ndeallocate(pef)
  
end Program Fill
