Program MPef

  use sep
  use read_hist_param
  use mpef_find
  use helix
  use createhelixmod
  use error_check
  
  implicit none
  
  integer, external                  :: getch
  integer                            :: nl, niter, prec,ritestat,nsc,tt(1000)!, dim
  integer, dimension(:), allocatable :: a,center,gap,npatch,sc,patch,nn,jump
  real                               :: eps, epsl
  character(len=1024)                :: out
  real,    dimension(:), pointer     :: data,mask
  real,    dimension(:), allocatable :: oo,dd
  type(filter)                      :: pef
  
! __________________________________________________________
! ___________Initialize and allocate parameters_____________
! __________________________________________________________
  call sep_init(SOURCE)
  dim = sep_dimension()
  nsc = getch("sc","d",tt)
  allocate(nn(dim),oo(dim),dd(dim),a(dim),center(dim),gap(dim),npatch(dim),sc(nsc),jump(dim))
! __________________________________________________________
! ___________Read history and parameters____________________
! __________________________________________________________
  call history_read(nn,oo,dd)
  call pefpar_read(a,center,gap,npatch,sc,jump,out)
  call cgpar_read(niter,prec,eps,epsl,nl)
! __________________________________________________________
! ___________Allocate data arrays and read data_____________ 
! __________________________________________________________
  allocate(data(product(nn)),mask(product(nn)))
  call sep_read(data)
  if (exist_file ("maskin")) then
     call sep_read(mask,"maskin")
  else
     mask=1.
  end if
! __________________________________________________________
! ___________Create PEF, set patch table (wrong)____________
! __________________________________________________________
  pef = createhelix( nn, center, gap, a)
! __________________________________________________________
! ___________Call main program to estimate PEF______________
! __________________________________________________________
!call rmms(data,"data ")
  call mpef_find(data,mask,nn,oo,dd,a,center,gap,niter,sc,jump,pef)
  call spefcheck(pef)
! __________________________________________________________
! ___________Write out filter to external file______________
! __________________________________________________________

  call sep_write(pef)
! __________________________________________________________
! ___________Deallocate and close program___________________
! __________________________________________________________

  call sep_close()
  allocate(pef%mis(1),pef%pch(1));pef%pch=size(pef%hlx)
  call deallocatehelix(pef)
  deallocate (nn,oo,dd,a,center,gap,data,mask)
  call exit(0)
end Program MPef
