program MakeMask2

use sep
use random_mod

implicit none

integer                                 :: n1, n2, i1, i2, well2, nknown, k1, k2, iseed
real                                    :: o1, o2, d1, d2, rand1, rand2, f, g, t
real                                    :: lag, count
real, dimension(:,:), allocatable       :: mask


call sep_init(SOURCE)

call from_param("n1", n1);  call from_param("n2", n2)
call from_param("d1", d1);  call from_param("d2", d2)
call from_param("o1", o1);  call from_param("o2", o2)

call from_param("datalag", lag, d1)
call from_param("nknown", nknown, nint(n1*n2/100.) )
call from_param("seed", iseed, 23450952 )

call to_history("n1", n1);  call to_history("n2", n2)
call to_history("d1", d1);  call to_history("d2", d2)
call to_history("o1", o1);  call to_history("o2", o2)

allocate( mask(n1,n2) );  
mask = 0.0

call random_init(iseed)

do i2=1,nknown
   do
      call rand_real(rand1)
      call rand_real(rand2)
      k2 = min( nint(n2*(rand1+1.0)), n2); k2 = max(1,k2)
      k1 = min( nint(n1*(rand2+1.0)), n1); k1 = max(1,k1)
      if (mask(k1,k2)==0.0) EXIT
   end do
   mask( k1,k2 ) = 1.0
end do
count=0
do i1=1,n1
   do i2=1,n2
      count = count + mask(i1,i2)
   end do
end do
write(0,*)'mask count',count
call sep_write(mask)

deallocate( mask)

end program MakeMask2
