program MakeMask3n

use sep
use random_mod

implicit none

integer                                 :: n1, n2, n3, i1, i2, i3, well2, nknown, k1, k2, k3, iseed
real                                    :: o1, o2, o3, d1, d2, d3, rand1, rand2, rand3, f, g, t
real                                    :: lag, count
real, dimension(:,:,:), allocatable     :: mask


call sep_init(SOURCE)

call from_param("n1", n1);  call from_param("n2", n2);  call from_param("n3", n3)
call from_param("d1", d1);  call from_param("d2", d2);  call from_param("d3", d3)
call from_param("o1", o1);  call from_param("o2", o2);  call from_param("o3", o3)

call from_param("nknown", nknown, nint(n1*n2/100.) )
call from_param("seed", iseed, 23450952 )

call to_history("n1", n1);  call to_history("n2", n2);  call to_history("n3", n3)
call to_history("d1", d1);  call to_history("d2", d2);  call to_history("d3", d3)
call to_history("o1", o1);  call to_history("o2", o2);  call to_history("o3", o3)

allocate( mask(n1,n2,n3) );  
mask = 0.0

call random_init(iseed)

do i2=1,nknown
   do
      call rand_real(rand1)
      call rand_real(rand2)
      call rand_real(rand3)
      k3 = min( nint(n3*(rand3+1.0)), n3);  k3 = max(1,k3)
      k2 = min( nint(n2*(rand2+1.0)), n2);  k2 = max(1,k2)
      k1 = min( nint(n1*(rand1+1.0)), n1);  k1 = max(1,k1)
      if (mask(k1,k2,k3)==0.0) EXIT
   end do
   mask( k1,k2,k3 ) = 1.0
end do
count=0
do i1=1,n1
   do i2=1,n2
      do i3=1,n3
         count = count + mask(i1,i2,i3)
      end do
   end do
end do

write(0,*)'mask count',count
call sep_write(mask)

deallocate( mask)

end program MakeMask3n
