Program Makescales
! Finds aa%mis for multiple scales of data, saves as a file
! mask - mask of missing data
! a - size of PEF
! center - position of leading 1 in PEF
! gap - size of zeroes after 1
! sc - scales to use, based on first dimension.  Must include original scale

use sep
use coarsen_norm_new
!use coarsen
use dottest

implicit none

! declarations

integer                                   :: stat, tt(1000), nsc, is
integer, dimension (:),   allocatable     :: nn, sc, mark, nmn, tmn
real,    dimension (:),   pointer         :: k0, coo, cdd
real,    dimension (:,:), pointer         :: co, cd
real,    dimension (:),   allocatable     :: oo, dd, data, output, tempout, nmin, nmax
integer, dimension (:,:), allocatable     :: mn
real,    dimension (2)                    :: dot1, dot2
integer, external                         :: getch

 ! read from history, param

  call sep_init(SOURCE)
  dim = sep_dimension()

  allocate(nn(dim),oo(dim),dd(dim),coo(dim),cdd(dim), tmn(dim),nmin(dim),nmax(dim))

  call from_history ("n",nn)
  call from_history ("o",oo)
  call from_history ("d",dd)

! Read scale parameters
  nsc = getch("sc","d",tt)
  allocate( sc(nsc), mn(nsc,dim), co(nsc,dim), cd(nsc,dim), mark(nsc+1), nmn(nsc*dim) )
  sc(1:nsc)=tt(1:nsc)
  call from_param ("sc", sc)
!write(0,*)"Parameters sc",sc,"nsc",nsc,"nn",nn
  mark=1
  do is=1,nsc
     mn(is,:)=int(sc(is)*nn(:)/nn(1))
     mark(is+1)=mark(is)+product(mn(is,:))
  end do

  allocate( data(product(nn)), k0(product(nn)), output(mark(nsc+1)-1))
  output=0

  call sep_read( data )
  k0 = 1.
  if (exist_file ("maskin"))  call sep_read( k0, "maskin")

  write(0,*)"mark", mark
  write(0,*)"mask", count(k0>0)
  do is=1,nsc
                                            write(0,*)"Makescales scale #",is
     allocate(tempout(product(mn(is,:))))
     tempout=0.
     tmn=mn(is,:)
     nmin = oo-dd/2.
     nmax = oo +dd*(nn-1.) +dd/2.        ! Great formula!
     cd(is,:) = (nmax-nmin)/tmn
     co(is,:) = (nmin*(tmn-.5) + nmax/2.)/tmn    ! Great formula!

     coo=co(is,:); cdd=cd(is,:)
     call coarsen_norm_init(nn,oo,dd,tmn,coo,cdd,k0)
                                            write(0,*)"Makescales init nn,mn",nn, tmn
                                            write(0,*)"Makescales prelop size tempout? ",size(output(mark(is):mark(is+1)-1)),size(tempout)
                                            write(0,*)"mix max size data",minval(data),maxval(data),size(data)
     stat = coarsen_norm_lop(.true., .false., tempout, data)
                                            write(0,*)"Makescales endloop tempout minmaxsize",minval(tempout),maxval(tempout),size(tempout)
                                            write(0,*)"Makescales postlop",size(tempout),size(output),mark(is),mark(is+1)-1
     output(mark(is):mark(is+1)-1) = tempout
     deallocate(tempout)
!                                            write(0,*)"Makescales deallocate"
     call coarsen_norm_close()
  end do

  write(0,*)"mix max size output",minval(output),maxval(output),size(output)
!  write(0,*)"co cd", co, cd
!  write(0,*)"oo dd", co, cd

  call to_history("n1", mark(nsc+1)-1)
  call to_history("n2", 1)
  call to_history("n3", 1)
  call to_history("n4", 1)

  call to_history("m",nn)
  nmn = reshape(mn,(/nsc*dim/))
  call to_history("nbank", nmn)

  call sep_write (output)
  call sep_close ()
  call exit (0)
  deallocate(nn,oo,dd,sc,co,cd,output,data,k0,mn)
end Program
