Program NMPef_nl

  use sep
  use read_hist_param
  use nlnmpef_find
  use nhelix
  use createnhelixmod
  use io_nfilt
  use error_check
  
  implicit none
  
  integer, external                  :: getch
  integer                            :: nl, niter, prec,ritestat,nsc,tt(1000),fiter,fprec,nliter,stat
  integer, dimension(:), allocatable :: a,center,gap,npatch,sc,patch,nn
  real                               :: eps, epsl, feps,fsig
  character(len=1024)                :: out,fname
  real,    dimension(:), pointer     :: data,mask
  real,    dimension(:), allocatable :: oo,dd
  type(nfilter)                      :: pef, pef2
  
! __________________________________________________________
! ___________Initialize and allocate parameters_____________
! __________________________________________________________
  call sep_init(SOURCE)
  dim = sep_dimension()
  nsc = getch("sc","d",tt)
  allocate(nn(dim),oo(dim),dd(dim),a(dim),center(dim),gap(dim),npatch(dim),sc(nsc))
! __________________________________________________________
! ___________Read history and parameters____________________
! __________________________________________________________
  call history_read(nn,oo,dd)
  call pefpar_read(a,center,gap,npatch,sc,(/1,1/),out)
  call cgpar_read(niter,prec,eps,epsl,nl)
  call fillpar_read(fname,feps,fsig,fiter,fprec)
  call from_param("nliter",nliter,5)
! __________________________________________________________
! ___________Allocate data arrays and read data_____________ 
! __________________________________________________________
  allocate(data(product(nn)),mask(product(nn)),patch(product(nn)))
  call sep_read(data)
  if (exist_file ("maskin")) then
     call sep_read(mask,"maskin")
  else
     mask=1.
  end if

  stat=read_nfilt(fname,pef)
! __________________________________________________________
! ___________Create PEF, set patch table (wrong)____________
! __________________________________________________________
  patch=product(npatch)
  pef2 = createnhelix( nn, center, gap, a, patch)
! __________________________________________________________
! ___________Call main program to estimate PEF______________
! __________________________________________________________

  !call nmpef_find(data,mask,nn,oo,dd,a,center,gap,npatch,niter,eps,prec,sc,pef,epsl,nl)
!  pef2%pch=pef%pch
write(0,*)"NM PEF: pef"
  call pefcheck(pef)
write(0,*)"NM PEF: pef2"
  call pefcheck(pef2)
! __________________________________________________________
! ________________Do nonlinear iterations___________________
! __________________________________________________________
  
  call nlnmpef_find(pef,data,mask,nn,oo,dd,a,center,gap,npatch,niter,eps,prec,sc,pef2,epsl,nl,nliter,feps,fiter)
!  call pefcheck(pef2)

! __________________________________________________________
! ___________Write out filter to external file______________
! __________________________________________________________

  ritestat=rite_nfilt(out,pef2,nn,oo,dd)
! __________________________________________________________
! ___________Deallocate and close program___________________
! __________________________________________________________

  call sep_close()
  allocate(pef%mis(1),pef%pch(1));pef%pch=size(pef%hlx)
  call ndeallocate(pef)
  deallocate (nn,oo,dd,a,center,gap,npatch,data,mask,patch)
  call exit(0)
end Program NMPef_nl

