Program NMPef_sean_2d

  use sep
  use read_hist_param
  use nmpef_find_sean
  use nhelix
  use createnhelixmod
  use io_nfilt
  use error_check
  
  implicit none
  
  integer, external                  :: getch
  integer                            :: nl, niter, prec,ritestat,nsc,tt(1000), pefdim!, dim
  integer, dimension(:), allocatable :: a,center,gap,npatch,sc,patch,nn,jump
  real                               :: eps, epsl
  character(len=1024)                :: out
  real,    dimension(:), pointer     :: dat,mask
  real,    dimension(:), allocatable :: oo,dd
  type(nfilter)                      :: pef


write(0,*)"NMPef 1"
! __________________________________________________________
! ___________Initialize and allocate parameters_____________
! __________________________________________________________
  call sep_init(SOURCE)
  dim = sep_dimension()
  pefdim=2
  nsc = getch("sc","d",tt)
  allocate(nn(dim),oo(dim),dd(dim),a(dim),center(pefdim),gap(pefdim),npatch(pefdim),sc(nsc),jump(pefdim))
write(0,*)"NMPef 2"
! __________________________________________________________
! ___________Read history and parameters____________________
! __________________________________________________________
  call history_read(nn,oo,dd)
write(0,*)"NMPef 3"
  call pefpar_read(a,center,gap,npatch,sc,jump,out)
write(0,*)"NMPef 4",jump
  call cgpar_read(niter,prec,eps,epsl,nl)
write(0,*)"NMPef 5"
! __________________________________________________________
! ___________Allocate data arrays and read data_____________ 
! __________________________________________________________
  allocate(dat(product(nn)),mask(product(nn)),patch(product(nn)))
write(0,*)"NMPef 6"
  call sep_read(dat)
write(0,*)"NMPef 7"
  if (exist_file ("maskin")) then
     call sep_read(mask,"maskin")
  else
     mask=1.
  end if
write(0,*)"NMPef 8"
! __________________________________________________________
! ___________Create PEF, set patch table (wrong)____________
! __________________________________________________________
  patch=product(npatch)
  pef = createnhelix( nn, center, gap, a, patch)
write(0,*)"NMPef 9"
! __________________________________________________________
! ___________Call main program to estimate PEF______________
! __________________________________________________________
!call rmms(data,"data ")
  call nmpef_find_sean(dat,mask,nn,oo,dd,a,center,gap,npatch,niter,eps,prec,sc,jump,pef,epsl,nl)
write(0,*)"NMPef 10"
  call pefcheck(pef)
write(0,*)"NMPef 11",pef%hlx(1)%flt
! __________________________________________________________
! ___________Write out filter to external file______________
! __________________________________________________________

  ritestat=rite_nfilt(out,pef,nn,oo,dd)
! __________________________________________________________
! ___________Deallocate and close program___________________
! __________________________________________________________

write(0,*)"NMPef 12"
  call sep_close()
write(0,*)"NMPef 13"
  allocate(pef%mis(1),pef%pch(1));pef%pch=size(pef%hlx)
write(0,*)"NMPef 14"
  call ndeallocate(pef)
write(0,*)"NMPef 15"
!  deallocate (nn,oo,dd,a,center,gap,npatch,dat,mask,patch)
  deallocate (nn,oo,dd,a,center,gap,npatch)
write(0,*)"NMPef 16"
  call exit(0)
write(0,*)"NMPef 17"
end Program NMPef_sean_2d
