Program NSPef_2d

  use sep
  use read_hist_param
  use npef_find
  use nhelix
  use createnhelixmod
  use io_nfilt
  use error_check

  implicit none

  integer                            :: nl, niter, prec,ritestat
  integer, dimension(:), allocatable :: a,center,gap,npatch,sc,patch,nn
  real                               :: eps, epsl
  character(len=1024)                :: out
  real,    dimension(:), pointer     :: data,mask
  real,    dimension(:), allocatable :: oo,dd
  type(nfilter)                      :: pef
! declarations

  call sep_init(SOURCE)
  dim = sep_dimension()
  
  allocate(nn(dim),oo(dim),dd(dim),a(dim),center(dim),gap(dim),npatch(dim))

  call history_read(nn,oo,dd)
  call pefpar_read(a,center,gap,npatch,out)
  call cgpar_read(niter,prec,eps,epsl,nl)

  allocate(data(product(nn)),mask(product(nn)),patch(product(nn)))
  call sep_read(data)
  if (exist_file ("maskin")) then
     call sep_read(mask,"maskin")
  else
     mask=1.
  end if

  patch=product(npatch)
  pef = createnhelix( nn, center, gap, a, patch)


  call npef_find(data,mask,nn,oo,dd,a,center,gap,npatch,niter,eps,prec,pef,epsl,nl)


! write(0,*) out filter
  ritestat=rite_nfilt(out,pef,nn,oo,dd)
! deallocate
  call sep_close()
  allocate(pef%mis(1),pef%pch(1));pef%pch=size(pef%hlx)
  call ndeallocate(pef)
  deallocate (nn,oo,dd,a,center,gap,npatch,data,mask,patch)
  call exit(0)

end Program NSPef_2d
