Program Rescale
! Finds aa%mis for multiple scales of data, saves as a file
! mask - mask of missing data
! a - size of PEF
! center - position of leading 1 in PEF
! gap - size of zeroes after 1
! sc - scales to use, based on first dimension.  Must include original scale

  use sep
  use dottest
  use nhelix
  use rescale_bill
  use read_hist_param
  use io_nfilt

  implicit none

! declarations

  integer                                   :: stat,fiter,fprec !,dim
  real                                      :: feps, fsig
  integer, dimension (:), allocatable       :: nn,sn, sc
  real,    dimension (:), allocatable       :: oo, dd, so, sd
  real,   dimension(:,:), allocatable       :: ob, db
  integer,dimension(:,:), allocatable       :: nb
  real,    dimension (:), pointer           :: data, mask, output
  real,    dimension (2)                    :: dot1, dot2
  type(nfilter)                             :: pef
  character(len=1024)                       :: fname
  ! read from history, param
  !                                                                          write(0,*)"BoundB 1"
  call sep_init(SOURCE)
  dim = sep_dimension()
  
  allocate(nn(dim),oo(dim),dd(dim),sc(1),sn(dim),so(dim),sd(dim))
 
  call history_read(nn,oo,dd)
  call fillpar_read(fname,feps,fsig,fiter,fprec)
  call from_param("sc",sc,nn)
  call find_nod(nn,oo,dd,sc,sn,so,sd)
write(0,*)"nod",nn,oo,dd
write(0,*)"s nod",sn,so,sd

  allocate( data(product(nn)), mask(product(nn)), output(product(sn)))
  call sep_read( data )
  call rmms(data,"data ")
  mask = 1.
  if (exist_file ("maskin"))  call sep_read( mask, "maskin")

  call rmms(mask,"mask ")

  if (exist_file ("filt")) then
     stat=read_nfilt(fname,pef)
     call pefcheck(pef)
     output=scale_data_pef(pef,data,mask,nn,oo,dd,sn,so,sd,feps,fiter)
     write(0,*)"after databankfind"
     call rmms(output,"out  ")
  else
     output=scale_data(data,mask,nn,oo,dd,sn,so,sd)
  end if

  call rmms(output,"out  ")
  call hist_nod(sn,so,sd)
  call sep_write (output)
  call sep_close ()
  call exit (0)
  deallocate(nn,oo,dd,sc,sn,so,sd,output,data,mask)
end Program
