module bbank

  use helix
  use createhelixmod
  use bound
  use misinput
  use coarsen_norm_new

  implicit none

  contains

  subroutine boundbank_find(mask,n,o,d,nbank,a,center,gap,bbank)
    type( filter )                                     :: aa
    integer, dimension(:)                              :: n, sc, a, center, gap
    integer, dimension(:,:)                            :: nbank
    real,    dimension(:)                              :: o, d, mask
    logical, dimension(:)                              :: bbank
    logical, dimension(:), allocatable                 :: lmask
    real,    dimension(:), allocatable                 :: rmask, no, nd, nmin, nmax
    integer, dimension(:), allocatable                 :: ni
    integer                                            :: i, nm, nb, stat

!                                                                           write(0,*)"bbank 1"
    allocate(ni(size(n)),no(size(n)),nd(size(n)),nmin(size(n)),nmax(size(n)))
    aa = createhelix(n, center, gap, a)
    bbank = 0
    nm = 1
!                                                                           write(0,*)"bbank 2"
    do i=1,size(nbank,1)
       ni = nbank(i,:)
       allocate(rmask(product(ni)),lmask(product(ni)))
       rmask=0; lmask=.false.
       nmin = o-d/2.
       nmax = o +d*(n-1.) +d/2.        ! Great formula!
       nd = (nmax-nmin)/ni
       no = (nmin*(ni-.5) + nmax/2.)/ni    ! Great formula!
!                                                                           write(0,*)"bbank 3",i,"o",o,"d",d,"n",n,"cn",ni
       call coarsen_init(n,o,d,ni,no,nd)
!                                                                           write(0,*)"bbank 4",i
       stat = coarsen_lop(.true.,.false.,rmask,mask)
                                                                           write(0,*)"bbank 5 i min max size rmask",i,minval(rmask),maxval(rmask),size(rmask)
       where (rmask>0) lmask=.true.
       call regridn (n, ni, aa)
       call boundn (ni,ni,a,aa)
       call find_mask (lmask,aa)
                                                                           write(0,*)"bbank 6",size(aa%mis)-count(aa%mis),size(aa%mis),ni, count(rmask==0)
       bbank(nm:nm+product(ni)-1) = aa%mis
       deallocate(aa%mis,lmask,rmask)
       nm = nm + product(ni)
       call regridn (ni, n, aa)
    end do
  end subroutine boundbank_find
end module bbank
