module fill_2pef

  use lint
  use nhelix
  use nheliconx2
  use npolydiv
  use cartesian
  use nbound_bob_mod
  use cgstep_mod
  use random
  use solver_smp_mod
  use solver_prc_mod
  use solver_reg_mod
  use error_check
  use rescale_bill
  use mask1
  
  implicit none

contains

  subroutine fill_grid         (pef1,pef2,datagrid,mask,model,prec,sigma,eps,iter)
    type(nfilter)            :: pef1,pef2
    real,dimension(:),pointer::     datagrid,     model
    logical,dimension(:),pointer::           mask
    integer                  ::                                   iter, i
    real                     ::                              sigma,eps
    logical                  ::                         prec
    real,dimension(:),allocatable :: rand

write(0,*)"begin fill_grid"
    allocate(rand(size(datagrid)))
    do i=1,size(rand)
       rand(i)=random_normal()*sigma
    end do
write(0,*)"fill_grid 1"
    mask=not(mask)
    call mask1_init(mask)
write(0,*)"fill_grid 2"    

    call nheliconx2_init(pef1,pef2)

call rmms(model,"model")
call rmms(datagrid,"datag")
call lmms(mask,"mask ")
call rmms(rand,"rand ")
     call pefcheck(pef1)
     call pefcheck(pef2)
write(0,*)"iter",iter
       call solver_smp(m=model,          &
                       d=datagrid,       &
                       Fop=nheliconx2_lop, &
                       stepper=cgstep,   &
                       niter=iter,       &
                       Kop=mask1_lop, &
                       m0=-datagrid,  &
                       verb=.true.)
       call nheliconz2_close()
write(0,*)"after solver"

    deallocate(rand)
  end subroutine fill_grid

end module fill_2pef
