module fill_2pefe

  use lint
  use nhelix
  use nheliconx2
  use npolydiv
  use cartesian
  use nbound_bob_mod
  use cgstep_mod
  use random
  use solver_smp_mod
  use solver_prc_mod
  use solver_reg_mod
  use error_check
  use rescale_bill
  use mask1
  use dottest
  
  implicit none

contains

  subroutine fill_2grid         (pef1,pef2,datagrid,mask,model,eps,iter)
    type(nfilter)            :: pef1,pef2
    real,dimension(:),pointer::     datagrid,     model
    logical,dimension(:),pointer::           mask
    integer                  ::                                   iter, i
    real                     ::                              eps,dot1(2),dot2(2)
    logical                  ::                         prec
    real,dimension(:),allocatable :: data2

write(0,*)"begin fill_grid"
write(0,*)"fill_grid 1"
!    mask=not(mask)
call lmms(mask,"mask ")
    call mask1_init(mask)
write(0,*)"fill_grid 2"
 
!    data2(1:size(datagrid))=datagrid
!    data2(size(datagrid)+1:size(data2))=datagrid
 
    call nheliconx2_init(pef1,pef2,size(datagrid))
write(0,*)"eps",eps
call rmms(model,"model")
call rmms(datagrid,"datag")
call lmms(mask,"mask ")
     call pefcheck(pef1)
     call pefcheck(pef2)
write(0,*)"iter",iter

if (eps==0) then
       call solver_smp(m=model,          &
                       d=datagrid,       &
                       Fop=nheliconx2_lop, &
                       stepper=cgstep,   &
                       niter=iter,       &
                       Kop=mask1_lop, &
                       m0=datagrid,  &
                       verb=.true.)
else
	call solver_reg(m=model,                                    &
        d=datagrid,                                   &
        Fop=mask1_lop, &
        Aop=nheliconx2_lop,                               &
        naop=size(datagrid)*2, &
        stepper=cgstep,                             &
        niter=iter,                                &
        m0=datagrid,                          &
        eps=eps, &
        verb=.true.)
end if

       call nheliconx2_close()
write(0,*)"after solver"

  end subroutine fill_2grid

end module fill_2pefe
