module lapfilln
! fill empty 2-D bins by minimum output of Laplacian operator
  use laplacian
  use cgstep_mod
  use solver_smp_mod
  use mask1
  implicit none
  contains
  subroutine lapfill               ( niter, n, yy, known)
    integer, intent (in) ::          niter, n(:)
    logical, dimension (:), pointer         ::     known
    ! mask for known
    real,    dimension (:), intent (in out) :: yy     ! model
    real,    dimension (:),allocatable                  :: zero   
    ! laplacian output
    allocate(zero(product(n)))
    call laplac_init (n)
    call mask1_init(known)
    zero = 0.      ! initialize
    call solver_smp ( m=yy,                &
                      d=zero,              &
                      Fop=laplac_lop,     &
                      stepper=cgstep,      &
                      niter=niter,         &
                      Kop=mask1_lop,       &
                      m0 = yy)
    call laplac_close ()
    ! garbage collection
    call cgstep_close ()
    ! garbage collection
    deallocate(zero)
  end subroutine lapfill
end module lapfilln
