module mhconest_new

use helix
use hconest
use sep
use adj_mod
use error_check

implicit none

type(filter),save                   :: aa
integer, private, save               :: dim, ns, stat
real, dimension(:), pointer, save    :: databank
integer, dimension(:), pointer, save :: lagbank,mark,lagmark
logical, dimension(:), pointer, save :: boundbank

contains

  subroutine mhconest_init(databank_in,boundbank_in,lagbank_in,   mark_in,   lagmark_in,aa_in)
    type(filter)     ::                                                                 aa_in
    integer, pointer ::                             lagbank_in(:),mark_in(:),lagmark_in(:)
    real,    pointer ::    databank_in(:)
    logical, pointer ::                boundbank_in(:)

    databank =>databank_in
    boundbank=>boundbank_in
    lagbank  =>lagbank_in
    mark     =>mark_in
    lagmark  =>lagmark_in
    aa       = aa_in
    ns = size(mark)-1
    
  end subroutine mhconest_init
! ---------------------------------------------------------------------------
! ---------------------------------------------------------------------------    
       
  function mhconest_lop ( adj, add, mm, dd) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: mm,dd 
    call adjnull (adj,add,mm,dd )
    call mhconest_lop2(adj,mm,dd )
    stat=0
  end function mhconest_lop

  subroutine mhconest_new_lop2( adj, mm, dd)
    logical                        :: adj 
    real, dimension(:)             :: mm, dd
    real, dimension(:),allocatable :: ddtemp
    real, dimension(:), pointer    :: datatemp
    integer, dimension(dim)        :: rn
    integer                        :: is, datsize, ia

!write(0,*)"nmhconest_lop start:",mark
!call rmms(mm,"mm   ")
!call rmms(dd,"dd   ")
    if (allocated(aa%mis)) then
       deallocate(aa%mis)
    endif
!write(0,*)"nmhconest_lop1",mark
!call imms(patchbank,"pbank")
    do is=1,ns                                      ! looping over scales
!write(0,*)"nmhconest_lop2",is

       datsize = mark(is+1)-mark(is)
!write(0,*)"nmhconest_lop3"
       allocate(aa%mis(datsize),datatemp(datsize),ddtemp(datsize))
!write(0,*)"nmhconest_lop4",mark(is),mark(is+1)-1
       ddtemp            =        dd(mark(is):mark(is+1)-1)
       datatemp          = databank(mark(is):mark(is+1)-1)
       aa%mis            = boundbank(mark(is):mark(is+1)-1)

       aa%lag =   lagbank(lagmark(is):lagmark(is+1)-1)

!write(0,*)"nmhconest_lop9"
       call hconest_init( datatemp, aa,size(aa%flt) )
!write(0,*)"nmhconest_lop10"
       stat = hconest_lop( adj, .true., mm, ddtemp )  ! Just normal nhconest--note add=.true.
!write(0,*)"nmhconest_lop11"
       dd(mark(is):mark(is+1)-1) = ddtemp
!write(0,*)"nmhconest_lop end:"
!call rmms(mm,"mm   ")
!call rmms(dd,"dd   ")
       deallocate( datatemp, ddtemp,aa%mis)
    end do
    
  end subroutine mhconest_new_lop2
! ---------------------------------------------------------------------------

! ---------------------------------------------------------------------------
  subroutine mhconest_close( )
  end subroutine mhconest_close
! ---------------------------------------------------------------------------

end module mhconest_new







