module nmhconest

use nhelix
use nhconest
use sep
use adj_mod
use regridn        

implicit none

type(nfilter), private, save         :: aa
integer, private, save               :: dim, ns, stat
real, dimension(:), pointer, save    :: dfg, ofg, patchbank, databank
integer, dimension(:), pointer, save :: oldpatch, nag, nsg, mark, lagbank, lagmark
logical, dimension(:), pointer, save :: misbank
integer, dimension(:,:), pointer, save :: nbank

contains

  subroutine nmhconest_init( databankin, aa0, nbankin, df, of, na, misbankin )
    type(nfilter)                    :: aa0
    real, dimension(:)               :: df, of
    real, dimension(:), pointer      :: rd, ro, databankin
    integer, dimension(:,:)          :: nbankin
    integer, dimension(:), pointer   :: na, newcart, patch, oldcart
    integer                          :: datsize, is, id, ip, banksize, oldline, stat, neq, nlag
    logical, dimension(:)            :: misbankin

                                                                               write(0,*)"size1 init"
    dim=size(nbankin,2)
                                                                               write(0,*)"size2 init dim", dim
    ns = size(nbankin,1)
                                                                               write(0,*)"allocate ns", ns
    allocate( misbank(size(misbankin)),databank(size(databankin)),oldpatch(size(aa0%pch)), mark(ns+1), lagmark(ns+1))
    allocate( dfg(dim), ofg(dim), nag(dim), nsg(dim),newcart(dim),oldcart(dim), nbank(ns,dim))
    aa = aa0; misbank = misbankin; databank=databankin
    dfg = df; ofg = of; nag = na; nbank=nbankin

    oldpatch = aa%pch
    mark(1)=1; lagmark(1)=1
                                                                               write(0,*)"setup lagmark"
    do is=2,ns+1
       mark(is) = mark(is-1) + product(nbank(is-1,:))
       lagmark(is) = lagmark(is-1) + size(aa%hlx(1)%lag)
    end do
                                                                               write(0,*)"after lagmark",lagmark
                                                                               write(0,*)"setup mark", mark

    banksize = mark(ns+1)-1
                                                                               write(0,*)"banksize",banksize
    allocate(patchbank(banksize))
write(0,*)"size5 init",ns,size(aa%hlx(1)%lag)
    allocate(lagbank(size(aa%hlx(1)%lag)*ns))
    lagbank = 0

    if (allocated(aa%mis)) then 
       deallocate(aa%mis)
    endif
    if (allocated(aa%pch)) then 
       deallocate(aa%pch)
    endif


write(0,*)"init 6"
! Loop over scales, set up everything
    do is=1,ns
       allocate(patch(product(nbank(is,:))))
! set up patchbank
       do ip=1,product(nbank(is,:))
         call line2cart(nbank(is,:),ip,newcart)
         do id=1,dim
            oldcart(id) = nint(real(newcart(id))*real(nbank(1,id))/real(nbank(is,id)))
         end do
         call cart2line(nbank(1,:),oldcart,oldline)
         patch(ip) = oldpatch(oldline)
       end do
       patchbank(mark(is):mark(is+1)-1) = patch
       deallocate(patch)
       allocate(aa%pch(product(nbank(is,:))))
! set up lagbank
       aa%pch=patchbank(mark(is):mark(is+1)-1)
       call nregridn(nbank(1,:),nbank(is,:),aa) 
       lagbank(lagmark(is):lagmark(is+1)-1)=aa%hlx(1)%lag
       call nregridn(nbank(is,:),nbank(1,:),aa)
    end do
    neq=count(.not. misbank)
     write(0,*)"Number of fitting equations:",neq
  end subroutine nmhconest_init
! ---------------------------------------------------------------------------
! ---------------------------------------------------------------------------    
       
  function nmhconest_lop ( adj, add, mm, dd) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: mm,dd 
    call adjnull (adj,add,mm,dd )
    call nmhconest_lop2(adj,mm,dd )
    stat=0
  end function 

  subroutine nmhconest_lop2( adj, mm, dd)
    logical                        :: adj 
    real, dimension(:)             :: mm, dd
    real, dimension(:), pointer    :: datatmp, datar
    integer, dimension(dim)        :: rn
    integer                        :: is, datsize, ia
 
    if (allocated(aa%pch)) then
       deallocate(aa%pch)
    endif
    if (allocated(aa%mis)) then
       deallocate(aa%mis)
    endif
    do is=1,ns                                      ! looping over scales
       datsize = product(nbank(is,:))
       allocate(aa%mis(datsize),aa%pch(datsize),datatmp(datsize),datar(datsize))
       datatmp = 0.0
       aa%mis = misbank(mark(is):mark(is+1)-1)
       aa%pch = patchbank(mark(is):mark(is+1)-1)
       do ia=1,maxval(aa%pch)
          aa%hlx(ia)%lag=lagbank(lagmark(is):lagmark(is+1)-1)
       end do
       datar = databank(mark(is):mark(is+1)-1)
       call nhconest_init( datar, aa,size(aa%hlx(1)%flt) )
       datatmp = dd(mark(is):mark(is+1)-1)
       stat = nhconest_lop( adj, .true., mm, datatmp )  ! Just normal nhconest--note add=.true.
       dd(mark(is):mark(is+1)-1) = datatmp
       deallocate( datatmp, datar)
       deallocate(aa%pch,aa%mis)
    end do
  end subroutine nmhconest_lop2
! ---------------------------------------------------------------------------

! ---------------------------------------------------------------------------
  subroutine nmhconest_close( )
		deallocate(databank,nbank,dfg,ofg,nag,oldpatch,patchbank,misbank,lagbank)
  end subroutine nmhconest_close
! ---------------------------------------------------------------------------

   end module nmhconest







