module nmhconest_new

use nhelix
use nhconest
use sep
use adj_mod
use error_check

implicit none

type(nfilter),save                   :: aa
integer, private, save               :: dim, ns, stat
real, dimension(:), pointer, save    :: databank
integer, dimension(:), pointer, save :: lagbank,mark,lagmark,patchbank
logical, dimension(:), pointer, save :: boundbank

contains

  subroutine nmhconest_new_init(databank_in,patchbank_in,boundbank_in,lagbank_in,   mark_in,   lagmark_in,aa_in)
   type(nfilter)    ::                                                                                    aa_in
    integer, pointer ::                     patchbank_in(:),          lagbank_in(:),mark_in(:),lagmark_in(:)
    real,    pointer ::     databank_in(:)
    logical, pointer ::                              boundbank_in(:)

    
    databank =>databank_in
    patchbank=>patchbank_in
    boundbank=>boundbank_in
    lagbank  =>lagbank_in
    mark     =>mark_in
    lagmark  =>lagmark_in
    aa       =aa_in
    ns = size(mark)-1
    
  end subroutine nmhconest_new_init
! ---------------------------------------------------------------------------
! ---------------------------------------------------------------------------    
       
  function nmhconest_new_lop ( adj, add, mm, dd) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: mm,dd 
    call adjnull (adj,add,mm,dd )
    call nmhconest_new_lop2(adj,mm,dd )
    stat=0
  end function nmhconest_new_lop

  subroutine nmhconest_new_lop2( adj, mm, dd)
    logical                        :: adj 
    real, dimension(:)             :: mm, dd
    real, dimension(:),allocatable :: ddtemp
    real, dimension(:), pointer    :: datatemp
    integer, dimension(dim)        :: rn
    integer                        :: is, datsize, ia

write(0,*)"nmhconest_lop start:",mark
!call rmms(mm,"mm   ")
!call rmms(dd,"dd   ")
    if (allocated(aa%pch)) then
       deallocate(aa%pch)
    endif
    if (allocated(aa%mis)) then
       deallocate(aa%mis)
    endif
!write(0,*)"nmhconest_lop1",mark
!call imms(patchbank,"pbank")
    do is=1,ns                                      ! looping over scales
!write(0,*)"nmhconest_lop2",is

       datsize = mark(is+1)-mark(is)
!write(0,*)"nmhconest_lop3"
       allocate(aa%mis(datsize),aa%pch(datsize),datatemp(datsize),ddtemp(datsize))
!write(0,*)"nmhconest_lop4",mark(is),mark(is+1)-1
!call imms(patchbank,"pbank")
       ddtemp            =        dd(mark(is):mark(is+1)-1)
!write(0,*)"nmhconest_lop5"
       datatemp          = databank(mark(is):mark(is+1)-1)
!write(0,*)"nmhconest_lop6"
!call imms(aa%pch,"aapch")
!call imms(patchbank(mark(is):mark(is+1)-1),"pbank")
       aa%mis            = boundbank(mark(is):mark(is+1)-1)
!write(0,*)"nmhconest_lop7",lagmark
       aa%pch            = patchbank(mark(is):mark(is+1)-1)
!call imms(aa%pch,"aapch")
!write(0,*)"nmhconest_lop8",maxval(aa%pch),size(aa%hlx)

       do ia=1,maxval(aa%pch)
          aa%hlx(ia)%lag =   lagbank(lagmark(is):lagmark(is+1)-1)
       end do

!write(0,*)"nmhconest_lop9"
       call nhconest_init( datatemp, aa,size(aa%hlx(1)%flt) )
!write(0,*)"nmhconest_lop10"
       stat = nhconest_lop( adj, .true., mm, ddtemp )  ! Just normal nhconest--note add=.true.
!write(0,*)"nmhconest_lop11"
       dd(mark(is):mark(is+1)-1) = ddtemp
!write(0,*)"nmhconest_lop end:"
!call rmms(mm,"mm   ")
!call rmms(dd,"dd   ")
       deallocate( datatemp, ddtemp,aa%pch,aa%mis)
    end do
    
  end subroutine nmhconest_new_lop2
! ---------------------------------------------------------------------------

! ---------------------------------------------------------------------------
  subroutine nmhconest_new_close( )
  end subroutine nmhconest_new_close
! ---------------------------------------------------------------------------

end module nmhconest_new







