module nmhconest_sean

use nhelix
use nhconest
use sep
use adj_mod
use error_check

implicit none

type(nfilter),save                   :: aa
integer, private, save               :: dim, ns, nd, stat, nl
real, dimension(:), pointer, save    :: data
integer, dimension(:), pointer, save :: lagbank,mark,lagmark
logical, dimension(:), pointer, save :: boundbank

contains

  subroutine nmhconest_sean_init(data_in,boundbank_in,lagbank_in,aa_in)
   type(nfilter)    ::                                           aa_in
    integer, pointer ::                               lagbank_in(:)
    real,    pointer ::          data_in(:)
    logical, pointer ::                  boundbank_in(:)
    
    data =>data_in
    boundbank=>boundbank_in
    lagbank  =>lagbank_in
    aa       =aa_in
    nd = size(data)
    ns = size(boundbank)/size(data)
    nl = size(aa%hlx(1)%lag)
  end subroutine nmhconest_sean_init
! ---------------------------------------------------------------------------
! ---------------------------------------------------------------------------    
       
  function nmhconest_sean_lop ( adj, add, mm, dd) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: mm,dd 
    call adjnull (adj,add,mm,dd )
    call nmhconest_sean_lop2(adj,mm,dd )
    stat=0
  end function nmhconest_sean_lop

  subroutine nmhconest_sean_lop2( adj, mm, dd)
    logical                        :: adj 
    real, dimension(:)             :: mm, dd
    real, dimension(:),allocatable :: ddtemp
    real, dimension(:), pointer    :: datatemp
    integer, dimension(dim)        :: rn
    integer                        :: is, datsize, ia

!call rmms(mm,"mm   ")
!call rmms(dd,"dd   ")
!call lmms(aa%mis,"aamis")
!call imms(aa%pch,"aapch")
!call imms(lagbank,"lbank")
!call lmms(boundbank,"bbank")
    do is=1,ns                                      ! looping over scales
       aa%mis            = boundbank(1+(is-1)*nd:(is*nd))
       do ia=1,size(aa%hlx)
          aa%hlx(ia)%lag =   lagbank(1+(is-1)*nl:(is*nl))
       end do
       call nhconest_init( data, aa,size(aa%hlx(1)%flt) )
       stat = nhconest_lop( adj, .true., mm, dd )  ! Just normal nhconest--note add=.true.
!call rmms(mm,"mm   ")
!call rmms(dd,"dd   ")
    end do
  end subroutine nmhconest_sean_lop2
! ---------------------------------------------------------------------------

! ---------------------------------------------------------------------------
  subroutine nmhconest_sean_close( )
  end subroutine nmhconest_sean_close
! ---------------------------------------------------------------------------

end module nmhconest_sean







