module nsfill2
  use mask1 
  use  nheliconx2
  use  npolydiv 
  use  cgstep_mod 
  use  solver_mod
  use  random_mod
implicit none
  contains
! fill in missing data by minimizing power out of a given filter.
! by helix magic works in any number of dimensions
  subroutine nsfill2_data( niter, xx, aa1, aa2, known, doprec, wght, sigma )
    logical,                intent( in)     :: doprec
    integer,                intent( in)     :: niter
    type( nfilter),          intent( in)     :: aa1,aa2
    logical, dimension( :), intent( in)     :: known
    real,    dimension( :), intent( in)     :: wght
    real,    dimension( :), intent( in out) :: xx	! fitting variables
    real,    dimension( :), allocatable     :: dd, res
    logical, dimension( :), pointer         :: kk
    integer                                 :: nx
    real                                    :: sigma
    nx = size( xx)
    allocate(res(nx))
    call rand_real_array_1d(res,amp=sigma)
write(0,*)"max/min/size res",maxval(res),minval(res),size(res)
write(0,*)"max/min/size xx",maxval(xx),minval(xx),size(xx)
    allocate(dd(nx))
write(0,*)"die -1"
    dd=0
write(0,*)"die 0"
write(0,*)"die 1"
!where (known)
!   dd=xx
!end where
!    where (.not.known)
!       dd=res
!    elsewhere
!       dd=xx
!    end where
write(0,*)"die 2"
!    if ( doprec) then
!  preconditioned
!write(0,*) 'mis2x - a'
!      allocate( kk( nx))
!      kk = known
!      call mask1_init( kk)
!      call npolydiv_init( nx, aa)
!write(0,*) 'mis2x - b'
!      call solver_prec( mask1_lop, cgstep, niter=niter, x=xx, dat=dd,prec= npolydiv_lop, nprec= nx, eps= 0., wt=wght)
!write(0,*) 'mis2x - c'
!      call npolydiv_close()
!      deallocate( kk)
!    else
!  regularized
      write(0,*)"count known",count(known)
      write(0,*)"min/max/size dd",minval(dd),maxval(dd),size(dd)
      call nheliconx2_init( aa1,aa2,nx)
write(0,*)"through init"
      call solver( nheliconx2_lop, cgstep, niter=niter, x=xx, dat=dd&
        &, known=known, x0=xx, wt=wght)
write(0,*)"after solver"
      deallocate( dd, res)
!    end if 
    call cgstep_close( )
  end subroutine 
end module 
